SystemOrganization addCategory: #'Casper-Core'!

Dictionary subclass: #PhClassModifierDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/8/2012 20:43'!
at: key includes: value

	|set|
	
	self at: key ifPresent: [:aSet| aSet includes: value].
	^false.! !

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/8/2012 23:26'!
at: key put: value

	|set|
	
	set := super at: key ifAbsent: [
		|s| 
		s:= Set new. 
		super at: key put: s. 
		s
	].
	set add: value.! !

!PhClassModifierDictionary methodsFor: 'removing' stamp: 'mcamp 10/8/2012 23:31'!
at: key remove: value

	|set|
	
	self at: key ifPresent: [:aSet| 
		aSet remove: value.
		aSet ifEmpty: [self removeKey: key].
	].! !

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/8/2012 21:06'!
atAll: keys put: value

	keys do:[:k| self at: k put: value].! !

!PhClassModifierDictionary methodsFor: 'removing' stamp: 'mcamp 10/8/2012 21:08'!
atAll: keys remove: value

	keys do:[:k| self at: k remove: value].! !

!PhClassModifierDictionary methodsFor: 'cleaning' stamp: 'mcamp 10/8/2012 20:33'!
cleanObsolete

	self keysDo: [:key| key isObsolete ifTrue:[self removeKey: key]].! !

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/16/2012 04:06'!
getAllClassModifiers

	|classModifiers|
	
	classModifiers := Set new.
	
	self valuesDo: [:values| classModifiers addAll: values].
	^classModifiers.! !

Object subclass: #PhAdvice
	instanceVariableNames: 'type advice pointcut objectSend selectorSend isSend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 8/29/2012 23:12'!
after: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #after.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 9/24/2012 04:25'!
after: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #after.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 8/29/2012 23:12'!
around: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #around! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 9/24/2012 04:25'!
around: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #around.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 8/29/2012 23:12'!
before: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #before.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 9/24/2012 04:25'!
before: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #before.! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 8/29/2012 23:09'!
advice
	^ advice! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:26'!
advice: aBlock
	isSend := false.
	advice := aBlock.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 10/22/2012 21:15'!
hasIfPointcut

	^pointcut hasIfBlock.! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
isSend
	^ isSend! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
objectSend
	^ objectSend! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
objectSend: anObject
	objectSend := anObject! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 8/29/2012 23:09'!
pointcut
	^ pointcut! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:27'!
pointcut: aPointcut
	pointcut := aPointcut! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
selectorSend
	^ selectorSend! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 10/18/2012 02:28'!
selectorSend: aSelector
	selectorSend := aSelector! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 10/18/2012 02:28'!
send: aSymbol to: anObjectOrBlock

	isSend := true.
	objectSend := anObjectOrBlock.
	selectorSend := aSymbol.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 10/22/2012 21:03'!
shouldExecuteOn: aCtx

	pointcut hasIfBlock ifTrue:[
		^pointcut ifBlock value: aCtx.
	].

	^true.! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 8/29/2012 23:09'!
type
	^ type! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:28'!
type: aSymbol
	type := aSymbol! !

Object subclass: #PhAdviceGroup
	instanceVariableNames: 'beforeAdvices aroundAdvices afterAdvices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addAdvice: advice.

	advice type == #before ifTrue:[self addBeforeAdvice: advice].
	advice type == #after ifTrue:[self addAfterAdvice: advice].
	advice type == #around ifTrue:[self addAroundAdvice: advice].! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:51'!
addAdvices: advices.

	advices do: [:adv| self addAdvice: adv].! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addAfterAdvice: advice

	afterAdvices add: advice.! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addAroundAdvice: advice

	aroundAdvices add: advice.! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addBeforeAdvice: advice

	beforeAdvices add: advice.! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:31'!
after

	^afterAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/25/2012 02:01'!
afterAdvices
	^ afterAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:30'!
afterAdvices: aCollection
	afterAdvices := aCollection! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/11/2012 12:39'!
allAdvices

	|collection|
	
	collection := OrderedCollection new.
	collection addAll: afterAdvices;
				addAll: beforeAdvices;
				addAll: aroundAdvices.
	^collection.! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:31'!
around

	^aroundAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/25/2012 02:01'!
aroundAdvices
	^ aroundAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:30'!
aroundAdvices: aCollection
	aroundAdvices := aCollection! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:31'!
before

	^beforeAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/25/2012 02:01'!
beforeAdvices
	^ beforeAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:30'!
beforeAdvices: aCollection
	beforeAdvices := aCollection! !

!PhAdviceGroup methodsFor: 'initialize-release' stamp: 'mcamp 9/28/2012 00:46'!
initialize

	super initialize.
	beforeAdvices := OrderedCollection new.
	afterAdvices := OrderedCollection new.
	aroundAdvices := OrderedCollection new.
	! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 10/18/2012 02:31'!
removeAdvice: anAdvice

	anAdvice type == #before ifTrue:[self removeBeforeAdvice: anAdvice].
	anAdvice type == #after ifTrue:[self removeAfterAdvice: anAdvice].
	anAdvice type == #around ifTrue:[self removeAroundAdvice: anAdvice].! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 03:01'!
removeAdvices: listAdvices

	listAdvices do: [:adv| self removeAdvice: adv].! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 01:08'!
removeAfterAdvice: anAdvice

	afterAdvices remove: anAdvice.! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 01:08'!
removeAroundAdvice: anAdvice

	aroundAdvices remove: anAdvice.! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 01:07'!
removeBeforeAdvice: anAdvice

	beforeAdvices remove: anAdvice.! !

Object subclass: #PhAspect
	instanceVariableNames: 'adviceCollection installed onWrappers classModifierCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAspect methodsFor: 'adding' stamp: 'mcamp 9/3/2012 21:45'!
add: anAdvice
	self adviceCollection add: anAdvice.! !

!PhAspect methodsFor: 'adding' stamp: 'mcamp 10/4/2012 04:00'!
addClassModifier: aCM
	classModifierCollection add: aCM.! !

!PhAspect methodsFor: 'adding' stamp: 'mcamp 9/4/2012 01:41'!
addWrapper: aWrapper

	onWrappers add: aWrapper! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 8/30/2012 00:09'!
adviceCollection
	^ adviceCollection! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:43'!
adviceCollection: aCollection
	adviceCollection := aCollection! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 02:02'!
classModifierCollection
	^ classModifierCollection! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:45'!
classModifierCollection: aCollection
	classModifierCollection := aCollection! !

!PhAspect methodsFor: 'testing' stamp: 'mcamp 10/4/2012 01:49'!
hasClassModifier

	^ classModifierCollection isEmptyOrNil not! !

!PhAspect methodsFor: 'initialize-release' stamp: 'mcamp 10/3/2012 03:36'!
initialize
	adviceCollection := OrderedCollection new.
	classModifierCollection := OrderedCollection new.
	installed := false.
	onWrappers := Set new.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 9/3/2012 21:07'!
install
	PhAspectWeaver installAspect: self.
	self installed: true.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 10/5/2012 01:01'!
installClassModifiers

	self classModifierCollection do:[:aCM|	
		aCM install.
	]! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 8/30/2012 00:09'!
installed
	^ installed! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 8/30/2012 00:09'!
installed: anObject
	installed := anObject! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 9/4/2012 01:17'!
onWrappers
	^ onWrappers! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:45'!
onWrappers: aSet
	onWrappers := aSet! !

!PhAspect methodsFor: 'removing' stamp: 'mcamp 8/30/2012 00:42'!
removeAdvice: anAdvice
	self adviceCollection remove: anAdvice.! !

!PhAspect methodsFor: 'removing' stamp: 'mcamp 9/5/2012 04:46'!
removeWrapper: aWrapper

	onWrappers remove: aWrapper! !

!PhAspect methodsFor: 'removing' stamp: 'mcamp 9/4/2012 01:26'!
removeWrappers

	onWrappers removeAll.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 9/5/2012 04:46'!
uninstall
	PhAspectWeaver uninstallAspect: self.
	self installed: false.
	self removeWrappers.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 10/5/2012 01:01'!
uninstallClassModifiers

	self classModifierCollection do:[:aCM|
		aCM uninstall.
	]! !

Object subclass: #PhAspectWeaver
	instanceVariableNames: ''
	classVariableNames: 'ClassModifierDict ClassModifiers CounterAspect InstalledAspects InstalledCasperSelectors InstalledWrappers Installing'
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:34'!
activateSystemNotification

	SystemAnnouncer uniqueInstance
		on: ClassAdded
		send: #onClassAdded:
		to: self.
		
	SystemAnnouncer uniqueInstance
		on: ClassModifiedClassDefinition
		send: #onClassModified:
		to: self.
	
	SystemAnnouncer uniqueInstance
		on: ClassRemoved
		send: #onClassRemoved:
		to: self.	
	
	SystemAnnouncer uniqueInstance
		on: ClassRenamed
		send: #onClassRenamed:
		to: self.	
	
	SystemAnnouncer uniqueInstance
		on: MethodAdded
		send: #onMethodAdded:
		to: self.	
	
	SystemAnnouncer uniqueInstance
		on: MethodModified
		send: #onMethodModified:
		to: self.	

	SystemAnnouncer uniqueInstance
		on: MethodRecategorized 
		send: #onMethodRecategorized:
		to: self.
		
	SystemAnnouncer uniqueInstance
		on: MethodRemoved
		send: #onMethodRemoved:
		to: self.! !

!PhAspectWeaver class methodsFor: 'adding' stamp: 'mcamp 10/15/2012 22:47'!
addAspect: anAspect
	
	self installedAspects add: anAspect.
	! !

!PhAspectWeaver class methodsFor: 'adding' stamp: 'mcamp 10/19/2012 01:38'!
addWrapper: aWrapper

	self installedWrappers at: (Array with: aWrapper wrappedClass with: aWrapper selector) ifAbsentPut: aWrapper.! !

!PhAspectWeaver class methodsFor: 'to remove' stamp: 'mcamp 10/9/2012 01:54'!
checkAspectBeforeRemove: aMethod inClass: aClass.

	self reinstallAspects.! !

!PhAspectWeaver class methodsFor: 'to remove' stamp: 'mcamp 10/12/2012 01:06'!
checkAspectOfClass: aClass categorized: aCategory source: aString notifyng: aController

	|sourceBuilder selector wrappers|
	
	(PhAspectWeaver isNewMethod: aString class: aClass) ifTrue:[
		aClass compile: aString classified: aCategory notifying: aController.
		PhAspectWeaver reinstallAspects.
	].
	
	sourceBuilder := PhSourceBuilder new
		source: aString asText;
		classBuilder: aClass.
	selector := sourceBuilder selector.
	wrappers := PhAspectWeaver getInstalledWrapperOf: aClass selector: selector.
	
	"si no tiene wrappers, vuelvo el metodo a su forma original"
	(wrappers isNil not and: [wrappers hasAspects not ]) 
		ifTrue: [
			|source|
			self flag:#removeWrapper.
			source := sourceBuilder changeToOriginalMethod: wrappers casperSelector.
			wrappers casperSelector:nil.
			^source.
		].
	
	"si tiene wrappers, genero el metodo de casper"
	wrappers ifNotNil: [ ^ sourceBuilder buildNewSource: wrappers. ].
	^aString.
	! !

!PhAspectWeaver class methodsFor: 'to remove' stamp: 'mcamp 10/12/2012 01:19'!
checkAspectToRemoveMethod: aMethod inClass: aClass

	|sourceBuilder wrappers cCategory|
	
	wrappers := PhAspectWeaver getInstalledWrapperOf: aClass selector: aMethod selector.
	sourceBuilder:= PhSourceBuilder new.
	sourceBuilder 
		source: aMethod sourceCode asText;
		classBuilder: aClass.
	
	
	
	"si tiene wrappers, elimino el metodo que correspode, sino, veo si es un metodo casper, si es asi, elimino el metodo original"
	(wrappers isNil not and: [wrappers hasAspects ]) 
		ifTrue: [
			|selectorCasper|
			selectorCasper := wrappers casperSelector.
			aClass removeSelector: selectorCasper
		]
		ifFalse:[ 
			"la manera de ver si es un metodo casper debe ser por el nombre y si el metodo original tiene wrappers!!"
			self flag:#correct.
			aMethod category asString = PhSourceBuilder casperCategory
			 ifTrue:[
				sourceBuilder changeBackSource: aMethod sourceCode asText.
				
				aClass removeSelector: (sourceBuilder selectorOfSource: sourceBuilder source asText class: aClass).
			]	
		].
	
	self flag:#refactorizar.
	self cleanCasperCategory: PhSourceBuilder casperCategory of: aClass.! !

!PhAspectWeaver class methodsFor: 'to remove' stamp: 'mcamp 10/9/2012 00:51'!
checkClassModifier: aClass

	" self reinstallClassModifiersOf: aClass.
	
	(self isClassModifier: aClass) ifTrue:[
		self reinstallAllInstaceOfClassModifiers: aClass.
	]"
	self reinstallAspects.! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/8/2012 20:52'!
classModifierDict

	^ ClassModifierDict ifNil: [ClassModifierDict := PhClassModifierDictionary new].! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/18/2012 03:41'!
cleanAndRemoveWrappersOfAspect: anAspect

	
	anAspect onWrappers do:[:wr| 
		wr removeAspect: anAspect.
		wr removeAdvices: anAspect adviceCollection.
		wr hasAspects ifFalse: [self removeWrapper: wr].
	]! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/18/2012 01:55'!
cleanAspectsOfWrappers

	self installedWrappers do: [:wr|
		wr cleanAspects.
	]

	! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/5/2012 01:21'!
cleanCasperCategory: aCategory of: aClass

	(aClass organization listAtCategoryNamed: aCategory)
		isEmptyOrNil ifTrue: [aClass removeCategory: aCategory] ! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/11/2012 02:26'!
counterAspect

	^ CounterAspect ifNil: [CounterAspect := 1000].! !

!PhAspectWeaver class methodsFor: 'adding' stamp: 'mcamp 10/11/2012 12:08'!
counterAspectAdd: aNumber

	CounterAspect := CounterAspect + aNumber .! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/16/2012 04:39'!
generateClassModifiers

	self installedAspects do:[:asp| 
		asp classModifierCollection do: [:cm|
			|classes|
			
			classes := cm pointcut getMatchedClasses.
			self classModifierDict atAll: classes put: cm.	
		]
	].
! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/16/2012 00:51'!
generateWrappers.

	self installedAspects do:[:asp| self updateWrappersWithAspect: asp].
! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/11/2012 12:08'!
getCounterAndAddOne

	|counter|
	counter := self counterAspect.
	self counterAspectAdd: 1.
	^counter.! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 01:37'!
getInstalledWrapperOf: aClass selector: aSelector
	"get the wrapper of aSelector of aClass, return the wrapper (only one) or nil"

	^self installedWrappers at: (Array with: aClass with: aSelector) ifAbsent:[nil].! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 01:43'!
getWrapperOfReceiver: aReceiver selector: aSelector

	^self installedWrappers 
		at: (Array with: aReceiver with: aSelector)
		ifAbsentPut: [
			|wr|
			wr := PhMethodWrapper new
					wrappedClass: aReceiver ;
					selector: aSelector.
			self addWrapper: wr.
			wr
		]
	! !

!PhAspectWeaver class methodsFor: 'testing' stamp: 'mcamp 10/19/2012 02:06'!
hasCasperSelector: aSelector ofClass: aClass

	self installedCasperSelectors 
		at: (Array with: aClass with: aSelector )
		ifPresent: [:arr| ^true]
		ifAbsent: [^false].

	^false.! !

!PhAspectWeaver class methodsFor: 'initialize-release' stamp: 'mcamp 10/19/2012 05:03'!
initialize
	super initialize.
	self activateSystemNotification.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/19/2012 00:41'!
installAspect: anAspect

	self uninstallAndCleanWrappers.
	self addAspect: anAspect.
	
	self installAspects. 
	

	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:48'!
installAspects

	self flag: #installing.
	self installing: true.
	
	self generateClassModifiers.
	self installClassModifiers.
	self generateWrappers.
	self installWrappers.
	
	self installing: false.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:49'!
installClassModifiers
	
	self flag: #installing.
	self installing: true.
	
	self classModifierDict keysAndValuesDo: [:cls :cms|
		cms do:[:cm| cm installOn: cls]	
	].

	self installing: false.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 01:28'!
installWrappers

	self flag: #installing.
	self installing: true.
	
	self installedWrappers do:[:wr|
		wr install.	
		self installedCasperSelectors 
			at: (Array with: wr wrappedClass with: wr selector)
			put: wr casperSelector.
	].

	self installing: false.! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 9/13/2012 03:39'!
installedAspects

	^ InstalledAspects ifNil: [InstalledAspects := Set new.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 01:31'!
installedCasperSelectors

	^ InstalledCasperSelectors ifNil: [InstalledCasperSelectors := Dictionary new.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 02:21'!
installedWrappers

	^ InstalledWrappers ifNil: [InstalledWrappers := Dictionary new.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/25/2012 00:42'!
installing

	^ Installing ifNil: [Installing := false.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/25/2012 00:43'!
installing: aBoolean

	Installing := aBoolean.! !

!PhAspectWeaver class methodsFor: 'testing' stamp: 'mcamp 10/19/2012 02:03'!
isCasperSelector: aCasperSelector ofClass: aClass

	self installedCasperSelectors keysAndValuesDo: [:anArray :aCspSel|
		((anArray at: 1) == aClass and: [aCspSel == aCasperSelector])
			ifTrue: [^true].
	].

	^false.! !

!PhAspectWeaver class methodsFor: 'to remove' stamp: 'mcamp 10/2/2012 03:06'!
isNewMethod: source class: aClass

	|selector| 
	selector := PhSourceBuilder selectorOfSource: source class: aClass.
	aClass methodDict at: selector ifAbsent: [^true.].
	^false.! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 00:45'!
onClassAdded: aClassAdded

	self installing ifFalse:[
		self reinstallAspects
	]! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:35'!
onClassModified: aClassModifiedClassDefinition

	self installing ifFalse:[
		self reinstallAspects
	]! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:35'!
onClassRemoved: aClassRemoved

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:35'!
onClassRenamed: aClassRenamed

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:36'!
onMethodAdded: aMethodAdded

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:36'!
onMethodModified: aMethodModified

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:36'!
onMethodRecategorized: aMethodRecategorized

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:37'!
onMethodRemoved: aMethodRemoved

	self flag:#installing.
	self installing ifFalse:[
		
	self installing:true.
	
	(self isCasperSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass)
		ifTrue: [self removeSelectorOfCasperSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass].
	(self hasCasperSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass)
		ifTrue: [self removeCasperSelectorOfSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass].
		
	self reinstallAspects.
	
	self installing: false.
	
	].
	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/19/2012 00:40'!
reinstallAspects

	self uninstallAndCleanWrappers.
	self uninstallClassModifiers.
	
	self installAspects.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/18/2012 03:29'!
removeAllWrappers

	self installedWrappers removeAll. ! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/18/2012 03:27'!
removeAspect: anAspect

	self installedAspects remove: anAspect.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:37'!
removeCasperSelectorOf: aSelector ofClass: aClass.

	self installedCasperSelectors
	removeKey: (Array with: aClass with: aSelector)
	ifAbsent:[].! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 03:35'!
removeCasperSelectorOfSelector: aSelector ofClass: aClass

	|casperSelector cCategory|
	
	casperSelector := self installedCasperSelectors at: (Array with: aClass with: aSelector).
	self removeSelector: casperSelector ofClass: aClass.
	self removeWrapperOfSelector: aSelector ofClass: aClass.
	self removeCasperSelectorOf: aSelector ofClass: aClass.
	
	self flag:#takelogicaway.
	cCategory := PhSourceBuilder casperCategory.
	(aClass organization listAtCategoryNamed: cCategory)
		isEmptyOrNil ifTrue: [aClass removeCategory: cCategory] ! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:11'!
removeSelector: aSelector ofClass: aClass

	aClass removeSelector: aSelector.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:40'!
removeSelectorOfCasperSelector: aCasperSelector ofClass: aClass

	self installedCasperSelectors keysAndValuesDo: [:anArray :aCspSel|
		((anArray at: 1) == aClass and:[aCspSel == aCasperSelector ])
			ifTrue:[
				self removeSelector: (anArray at: 2) ofClass: aClass.	
				self removeWrapperOfSelector: (anArray at: 2) ofClass: aClass.
				self removeCasperSelectorOf: (anArray at: 2) ofClass: aClass.
			]	
	]! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 01:46'!
removeWrapper: aWrapper

	self installedWrappers 
	removeKey: (Array with: aWrapper wrappedClass with: aWrapper selector)
	ifAbsent:[].! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:30'!
removeWrapperOfSelector: aSelector ofClass: aClass.

	self installedWrappers 
		removeKey: (Array with: aClass with: aSelector)
		ifAbsent:[].! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 9/13/2012 03:40'!
uninstallAll

	self installedAspects do:[:aspect| aspect uninstall].! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:48'!
uninstallAndCleanWrappers

	self flag:#installing.
	self installing: true.
	
	self uninstallAspectsWithoutRemove.
	self cleanAspectsOfWrappers.
	
	self installing: false.
	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/18/2012 03:41'!
uninstallAspect: anAspect

	self uninstallAspectsWithoutRemove.
	self cleanAndRemoveWrappersOfAspect: anAspect.
	self removeAspect: anAspect.
	
	self cleanAspectsOfWrappers.
	self installAspects.
	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/16/2012 02:35'!
uninstallAspectsWithoutRemove

	self uninstallWrappers.
	self uninstallClassModifiers.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:47'!
uninstallClassModifiers

	self flag:#installing.
	self installing: true.

	self classModifierDict keysAndValuesDo: [:cls :cms|
		cms do:[:cm| cm uninstallOn: cls].
	].
	self classModifierDict removeAll.
	
	self installing: false.

	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:40'!
uninstallWrappers

	self installedWrappers do:[:wr| 
		wr uninstall.
		self installedCasperSelectors
			removeKey: (Array with: wr wrappedClass with: wr selector)
	].! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/15/2012 22:49'!
updateWrappersWithAspect: anAspect

	anAspect adviceCollection do:[ :adv|
		adv pointcut getPointcuts do:[:pc| |mw|
			mw := self getWrapperOfReceiver: (pc at:1) selector: (pc at:2).
			mw addAdvice: adv.
			
			mw addAspect: anAspect.
			self addWrapper: mw.
			anAspect addWrapper: mw.
		]
	].! !

Object subclass: #PhClassModifier
	instanceVariableNames: 'newInstanceVars newMethods newClassVars newClassMethods pointcut onClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/4/2012 03:58'!
addMethod: aSymbol
	newMethods add: aSymbol.! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:28'!
addNewClassMethod: aSymbol
	newClassMethods add: aSymbol! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:29'!
addNewClassVar: aSymbol
	newClassVars add: aSymbol.! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:29'!
addNewInstanceMethod: aSymbol
	newMethods add: aSymbol.! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:29'!
addNewInstanceVar: aSymbol
	newInstanceVars add: aSymbol.! !

!PhClassModifier methodsFor: 'private' stamp: 'mcamp 10/16/2012 04:27'!
checkIfCanInstallOn: aClass


	newInstanceVars
		do: [ :varName | 
			(aClass theNonMetaClass hasInstVarNamed: varName)
				ifTrue: [ self error: 'instance variable already defined!!' ] ].
	newClassVars
		do: [ :varName | 
			(aClass theNonMetaClass hasClassVarNamed: varName)
				ifTrue: [ self error: 'class variable already defined!!' ] ].
	newMethods
		do: [ :selector | 
			(aClass theNonMetaClass allSelectors includes: selector)
				ifTrue: [ self error: 'instance method already defined!!' ] ].
	newClassMethods
		do: [ :selector | 
			(aClass theMetaClass allSelectors includes: selector)
				ifTrue: [ self error: 'class method already defined!!' ] ].! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:28'!
compileClass: class WithMethodsProvidedBy: aClass.

	self compileInstVarsOn: class.
	self compileClassVarsOn: class.
	self compileInstMethodsOn: class providedBy: aClass.
	self compileClassMethodsOn: class providedBy: aClass.
	! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileClassMethodsOn: class providedBy: aClass

	|sources|
	
	sources := newClassMethods collect: [:m| (aClass methodDict at: m) sourceCode].
	 
	sources do:[:source|
		class theMetaClass compile: source classified: PhSourceBuilder casperClassModifiedCategory
		
	].
	! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileClassVarsOn: aClass

	newClassVars do:[:clsVar| aClass addClassVarNamed: clsVar].! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/5/2012 01:16'!
compileClasses: classes WithMethodsProvidedBy: aClass.

	self compileInstVarsOn: classes.
	self compileClassVarsOn: classes.
	self compileInstMethodsOn: classes providedBy: aClass.
	self compileClassMethodsOn: classes providedBy: aClass.
	! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileInstMethodsOn: class providedBy: aClass

	|sources|
	
	sources := newMethods collect: [:m| (aClass methodDict at: m) sourceCode].

	sources do:[:source|
		class compile: source classified: PhSourceBuilder casperClassModifiedCategory
	
	].! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileInstVarsOn: class

	|instVarString|
	instVarString := ''.
	newInstanceVars  do:[:aInstVar| instVarString := instVarString,' ',aInstVar ].
	class addInstVarNamed: instVarString.
	! !

!PhClassModifier methodsFor: 'initialize-release' stamp: 'mcamp 10/3/2012 03:33'!
initialize

	super initialize.
	newClassMethods := OrderedCollection new.
	newClassVars := OrderedCollection new.
	newInstanceVars := OrderedCollection new.
	newMethods := OrderedCollection new.! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'mcamp 10/16/2012 04:26'!
installOn: aClass

	self checkIfCanInstallOn: aClass.
	self compileClasses: aClass WithMethodsProvidedBy: self class.
	! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassMethods
	^ newClassMethods! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassMethods: anObject
	newClassMethods := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassVars
	^ newClassVars! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassVars: anObject
	newClassVars := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newInstanceVars
	^ newInstanceVars! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newInstanceVars: anObject
	newInstanceVars := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newMethods
	^ newMethods! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newMethods: anObject
	newMethods := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 13:03'!
onClasses
	^ onClasses! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 13:03'!
onClasses: anObject
	onClasses := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/3/2012 03:35'!
pointcut
	^ pointcut! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/3/2012 03:35'!
pointcut: anObject
	pointcut := anObject! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/18/2012 02:59'!
removeChangeOfClass: class.

	self removeClassMethodsOf: class.
	self removeInstMethodsOf: class.
	self removeClassVarOf: class.
	self removeInstVarOf: class.
		
	PhAspectWeaver cleanCasperCategory: PhSourceBuilder casperClassModifiedCategory of: class.
	! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/12/2012 00:54'!
removeClassMethodsOf: aClass

	newClassMethods do:[:selector|
		aClass theMetaClass methodDict at: selector ifPresent:[:method|
			PhAspectWeaver checkAspectToRemoveMethod: method  inClass: aClass theMetaClass.
			aClass theMetaClass removeSelector: selector.
		].
	]
	
! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/8/2012 21:36'!
removeClassVarOf: aClass

	newClassVars do:[:var|
		(aClass classPool includesKey: var ) ifTrue: [
			aClass removeClassVarNamed: var.
		].
	].! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/9/2012 01:27'!
removeInstMethodsOf: aClass

	newMethods do:[:selector| 
		aClass methodDict at: selector ifPresent: [:method|
			PhAspectWeaver checkAspectToRemoveMethod: method  inClass: aClass.
			aClass removeSelector: selector.
		].
	]! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/8/2012 21:37'!
removeInstVarOf: aClass

	newInstanceVars do:[:var| 
		(aClass instVarNames includes: var) ifTrue: [
			aClass removeInstVarNamed: var
		].
	]! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'mcamp 10/18/2012 03:46'!
uninstallOn: aClass

	self removeChangeOfClass: aClass.
	
	
	
! !

Object subclass: #PhContext
	instanceVariableNames: 'arguments dynamicContext receiver selector sender nextContext proceed isOriginal thisAdvice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
arguments
	^ arguments! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:04'!
arguments: anArray
	arguments := anArray! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
dynamicContext
	^ dynamicContext! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
dynamicContext: anObject
	dynamicContext := anObject! !

!PhContext methodsFor: 'initialize-release' stamp: 'mcamp 9/24/2012 01:09'!
initialize

	super initialize.
	isOriginal := false.! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 9/24/2012 01:08'!
isOriginal
	^ isOriginal! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 10/18/2012 03:05'!
isOriginal: aBoolean
	isOriginal := aBoolean! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 9/24/2012 01:02'!
nextContext
	^ nextContext! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 10/18/2012 03:07'!
nextContext: aContext
	nextContext := aContext! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 9/24/2012 01:09'!
proceed
	^ isOriginal ifTrue:[ proceed value] ifFalse: [proceed value: nextContext].! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 9/24/2012 01:05'!
proceed: aBlock
	proceed := aBlock! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
receiver
	^ receiver! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
receiver: anObject
	receiver := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
selector
	^ selector! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:07'!
selector: aSelector
	selector := aSelector! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
sender
	^ sender! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
sender: anObject
	sender := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/11/2012 13:20'!
thisAdvice
	^ thisAdvice! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:08'!
thisAdvice: anAdvice
	thisAdvice := anAdvice! !

Object subclass: #PhMethodWrapper
	instanceVariableNames: 'aspects adviceGroup casperSelector casperCounter wrappedClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhMethodWrapper methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:58'!
addAdvice: anAdvice
	
	adviceGroup addAdvice: anAdvice.
	! !

!PhMethodWrapper methodsFor: 'adding' stamp: 'mcamp 9/4/2012 01:21'!
addAspect: anAspect

	aspects add: anAspect.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:55'!
adviceGroup
	^ adviceGroup! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:09'!
adviceGroup: anAdvGroup
	adviceGroup := anAdvGroup! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 02:18'!
advices
	^adviceGroup.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:01'!
afterAdvices
	^adviceGroup afterAdvices.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:01'!
aroundAdvices
	^ adviceGroup aroundAdvices ! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/4/2012 01:19'!
aspects
	^ aspects! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:09'!
aspects: aSet
	aspects := aSet! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:02'!
beforeAdvices
	^ adviceGroup beforeAdvices! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/12/2012 02:36'!
casperCounter
	^ casperCounter! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:10'!
casperCounter: anString
	casperCounter := anString! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/11/2012 12:15'!
casperSelector
	^ casperSelector! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:10'!
casperSelector: aSelector
	casperSelector := aSelector! !

!PhMethodWrapper methodsFor: 'private' stamp: 'mcamp 10/18/2012 03:13'!
cleanAspects

	self flag:#refactorizar.
	"use remove all"
	aspects := Set new.
	adviceGroup := PhAdviceGroup new.
	
	! !

!PhMethodWrapper methodsFor: 'common' stamp: 'mcamp 10/11/2012 15:53'!
commonContext

	|contexts|
	
	contexts := Set new.
	adviceGroup allAdvices do:[:adv| 
		(adv pointcut context) ifNotNil: [contexts addAll: (adv pointcut context) ].
	].
	^contexts.! !

!PhMethodWrapper methodsFor: 'testing' stamp: 'mcamp 9/4/2012 01:32'!
hasAspects

	^ aspects isEmptyOrNil not.! !

!PhMethodWrapper methodsFor: 'initialize-release' stamp: 'mcamp 9/28/2012 00:45'!
initialize

	super initialize.
	aspects := Set new.
	adviceGroup := PhAdviceGroup new.! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'mcamp 10/18/2012 00:55'!
install

	|sourceBuilder newSource category|
	
	"take out source:, build from sourceBuilder"
	self flag: #takeOutSource.
	sourceBuilder := PhSourceBuilder new
		source: (wrappedClass methodDict at:  selector) sourceCode asText;
		classBuilder: wrappedClass;
		selector: selector.
	
	category := (wrappedClass methodDict at: selector) category.
	newSource := sourceBuilder buildNewSource: self.
	
	wrappedClass compile: newSource classified: category.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:02'!
removeAdvices: advices

	adviceGroup removeAdvices: advices.
	
	
	! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/13/2012 04:03'!
removeAspect: anAspect

	aspects remove: anAspect ifAbsent:[].
	! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:08'!
selector
	^ selector! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:12'!
selector: aSelector
	selector := aSelector! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'mcamp 10/16/2012 03:37'!
uninstall

	|sourceBuilder originalSource cCategory originalCategory |
	
	sourceBuilder := PhSourceBuilder new
		source: (wrappedClass methodDict at:  selector) sourceCode asText;
		classBuilder: wrappedClass.
	
	originalSource := sourceBuilder originalSourceCodeOf: selector casperSelector: casperSelector.
	
	wrappedClass removeSelector: casperSelector.
	originalCategory := (wrappedClass methodDict at: selector) category.
	wrappedClass compile: originalSource classified: originalCategory.
	
	"clean casper category"
	cCategory := PhSourceBuilder casperCategory.
	(wrappedClass organization listAtCategoryNamed: cCategory)
		isEmptyOrNil ifTrue: [wrappedClass removeCategory: cCategory] ! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:08'!
wrappedClass
	^ wrappedClass! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:12'!
wrappedClass: aClass
	wrappedClass := aClass! !

Object subclass: #PhPointcutAbstract
	instanceVariableNames: 'ifBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

PhPointcutAbstract subclass: #PhPointcut
	instanceVariableNames: 'receivers selectors withinClasses context pragmas package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 01:34'!
context
	^ context! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 01:34'!
context: anObject
	context := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 14:26'!
getMatchedClasses
	|classes rm|
	
	classes := Set new.
	receivers isString 
		ifTrue:[
			rm := PhReceiverMatcher receivers: receivers. 
			rm withinClasses: self getRestrictionClasses. 
			classes addAll: rm getAllReceiversThatMatch.
		]
		ifFalse:[
			receivers do:[:r|
				rm := PhReceiverMatcher receivers: r.
				rm withinClasses: self getRestrictionClasses. 
				classes addAll: rm getAllReceiversThatMatch.
			].
		].
	^classes.! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 14:25'!
getPointcuts
	|classes methods rm pm|
	
	methods := OrderedCollection new.
	
	"match pragma"
	pragmas isEmptyOrNil ifFalse: [
		pm := PhPragmaMatcher new buildMatch: pragmas. 	
	].

	"que pase esta logica a la clase PhReceiverMatcher"
	self flag: #refactoring.
	classes := self getMatchedClasses.
	
	classes do: [:aClass| 
		|sel|
		
		"selectors nil means all selector on pragmas"
		selectors isEmptyOrNil 	ifFalse: [
			sel :=((PhSelectorMatcher selectors: selectors) getAllMethodsThatMatchOfClass: aClass).
		].
	
		"match pragma"
		pragmas isEmptyOrNil ifFalse: [
			sel := pm withinClass: aClass;
					withinMethods: sel;
					methodsMatchPragma. 	
		].
		
		methods addAll: (sel collect: [:aSelector| Array with: aClass with: aSelector selector]).
	].
	^ methods asSet.! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:30'!
getRestrictionClasses

	withinClasses isNil 
		ifTrue: [^Smalltalk allClasses]
		ifFalse: [^withinClasses].! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:30'!
package
	^ package! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:32'!
package: anObject
	package := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:50'!
pragmas
	^ pragmas! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:50'!
pragmas: anObject
	pragmas := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
receivers
	^ receivers! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
receivers: aString
	receivers := aString! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:43'!
restrictToPackages: anArray

	|classes|
	
	package := anArray.
	classes := Set new.
	anArray do:[:aPackage|
		(PackageOrganizer default packageNamed: aPackage ifAbsent:[nil])
		ifNotNil:[:packageInfo|
			classes addAll: packageInfo classes.
		]
	].
	withinClasses := classes.! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
selectors
	^ selectors! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
selectors: aString
	selectors := aString! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 22:48'!
withinClasses
	^ withinClasses! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 22:48'!
withinClasses: anObject
	withinClasses := anObject! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:38'!
getPointcuts
	
	^self subclassResponsibility.! !

!PhPointcutAbstract methodsFor: 'testing' stamp: 'mcamp 10/22/2012 20:34'!
hasIfBlock
	^ ifBlock isNil not.! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'mcamp 10/22/2012 20:02'!
if: aBlock
	ifBlock := aBlock! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'mcamp 10/22/2012 20:02'!
ifBlock
	^ ifBlock! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'mcamp 10/22/2012 20:03'!
ifBlock: aBlock
	ifBlock := aBlock! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 8/28/2012 15:09'!
not
	
	^PhPointcutNot new
		pointcut: self.! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 8/28/2012 15:09'!
pand: aPointcut.
	
	^ PhPointcutAnd new
		leftPointcut: self;
		rightPointcut: aPointcut.! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 8/28/2012 15:08'!
por: aPointcut.
	
	^ PhPointcutOr new
		leftPointcut: self;
		rightPointcut: aPointcut.! !

PhPointcutAbstract subclass: #PhPointcutAnd
	instanceVariableNames: 'leftPointcut rightPointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:41'!
getPointcuts
	
	 ^leftPointcut getPointcuts intersection: rightPointcut getPointcuts.! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
leftPointcut
	^ leftPointcut! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
leftPointcut: anObject
	leftPointcut := anObject! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
rightPointcut
	^ rightPointcut! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
rightPointcut: anObject
	rightPointcut := anObject! !

PhPointcutAbstract subclass: #PhPointcutNot
	instanceVariableNames: 'pointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcutNot methodsFor: 'accessing' stamp: 'MiguelCampusano 8/20/2012 03:52'!
getPointcuts
	|originalPointcuts classes newPointcuts|
	
	self flag:#createListOfPoincuts.
	newPointcuts := Set new.
	
	originalPointcuts := pointcut getPointcuts.

	classes :=  (originalPointcuts collect:[:p| p at: 1]).
	
	pointcut getRestrictionClasses
		do: [:aClass| 
			(Array with: aClass with: aClass class) do:[:each|
				(classes includes: each)
					ifTrue:[
						|selectors newSelectors|
						selectors:= originalPointcuts select: [:p| (p at:1) == each] thenCollect:[:p| p at: 2].
						newSelectors := each allSelectors asSet difference: selectors asSet.
						newPointcuts addAll: (newSelectors collect:[:aSelector| Array with: each with: aSelector]).
					]
					ifFalse:[
						newPointcuts addAll: (each allSelectors collect:[:aSelector| Array with: each with: aSelector])	
					]
			]
		].
	^ newPointcuts.! !

!PhPointcutNot methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:56'!
pointcut
	^ pointcut! !

!PhPointcutNot methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:56'!
pointcut: anObject
	pointcut := anObject! !

PhPointcutAbstract subclass: #PhPointcutOr
	instanceVariableNames: 'leftPointcut rightPointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
getPointcuts
	
	 ^leftPointcut getPointcuts union: rightPointcut getPointcuts.! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
leftPointcut
	^ leftPointcut! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
leftPointcut: anObject
	leftPointcut := anObject! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
rightPointcut
	^ rightPointcut! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
rightPointcut: anObject
	rightPointcut := anObject! !

Object subclass: #PhPragmaMatcher
	instanceVariableNames: 'withinMethods withinClass arrayPragmaWithWildcards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPragmaMatcher methodsFor: 'private' stamp: 'mcamp 10/2/2012 00:04'!
argument: anObject equal: otherObject

	"OrderedCollection and Array no son iguales, no importa pq solo se usa en pragma"
	(anObject class == otherObject class ) ifFalse: [^false].
	(anObject isArray and:[otherObject isArray]) ifTrue:[
		(1 to: anObject size) do:[:index|
			(self argument: (anObject at: index ) equal: (otherObject at: index)) ifFalse:[
				^false.	
			]
		].
		^true.
	].

	^ anObject = otherObject ! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:01'!
arrayPragmaWithWildcards
	^ arrayPragmaWithWildcards! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:01'!
arrayPragmaWithWildcards: anObject
	arrayPragmaWithWildcards := anObject! !

!PhPragmaMatcher methodsFor: 'building' stamp: 'mcamp 9/22/2012 14:45'!
buildMatch: listOrString
	
	listOrString isString 
		ifTrue: [self buildMatchOfString: listOrString]
		ifFalse:[
			listOrString do:[:reg|
				self buildMatchOfString: reg.	
			]	
		]
	

	! !

!PhPragmaMatcher methodsFor: 'building' stamp: 'mcamp 10/1/2012 22:09'!
buildMatchOfString: aRegExp

	|pragma rs index nw txt positionsArgs positionName withoutArgs wildCard|
	
	pragma := PhPragmaWithWildcards new.
	positionsArgs := OrderedCollection new.
	withoutArgs := false.
	wildCard := false.
	positionName := 0.
	rs := aRegExp readStream.
	index := 0.
	"limpio blancos"
	[nw := rs next.
	 nw = Character space] whileTrue:[].

	[(nw == nil) not ] whileTrue:[
		index := index + 1. 
		Transcript show: index.
		(nw== $_) ifTrue: [
			pragma addWildcardName: index. 
			positionName := rs position.
			wildCard := true.
		].
		
		"pragma con argumentos"
		[nw := rs next. ((nw == nil) not and: [(nw == $:) not] )and:[(nw == Character space) not] ] whileTrue:[].
	
		"sin argumentos"
		(nw == nil or:[ nw == Character space] )ifTrue:[withoutArgs := true].
		"con argumentos nw == $:"
		nw == $: ifTrue:[
			"limpio blancos"
			[nw := rs next.
			 nw = Character space] whileTrue:[].
		
			nw == $_ ifTrue:[
				pragma addWildcardArgs: index.
				positionsArgs add: rs position.
			].
		
			"limpio blancos"
			[nw := rs next.
			 nw = Character space] whileTrue:[].
		]
	].
	
	txt := aRegExp asText.
	"replace wildCardName only when is without args"
	(wildCard and: [withoutArgs and:[ index == 1]]) ifTrue:[ txt replaceFrom: positionName  to: positionName - 1 with: 'p'.].
	
	"replace wildCardsArgs to create pragma"
	positionsArgs reverseDo:[:i|
		txt replaceFrom: i + 1 to: i with: ''''.
		txt replaceFrom: i to: i - 1 with: ''''.
	].

	"create pragma"
	pragma pragma:(self pragmaFromText: txt).
	arrayPragmaWithWildcards add: pragma.
	! !

!PhPragmaMatcher methodsFor: 'initialize-release' stamp: 'mcamp 10/1/2012 20:01'!
initialize

	super initialize.
	arrayPragmaWithWildcards  := OrderedCollection new.! !

!PhPragmaMatcher methodsFor: 'matching' stamp: 'mcamp 10/1/2012 22:44'!
matchPragma: p

	arrayPragmaWithWildcards do:[:pwd|
		(self pragma: p matchWithWildcard: pwd ) ifTrue:[^true].
	].
	^false.! !

!PhPragmaMatcher methodsFor: 'matching' stamp: 'mcamp 9/22/2012 15:47'!
methodsMatchPragma

	|methodsMatch|
	
	^self restrictionMethods select:[ :m|
		|pragmas|
		pragmas := m pragmas select: [:p|	self matchPragma: p].
		pragmas isEmptyOrNil not.
	]
	! !

!PhPragmaMatcher methodsFor: 'matching' stamp: 'mcamp 10/1/2012 23:29'!
pragma: aPragma matchWithWildcard: aPragmaWithWildcards

	|keywords arguments keyToMatch argToMatch wildcardNames wildcardArgs |
	
	keywords  := aPragma key subStrings: ':'.
	arguments := aPragma arguments.
	keyToMatch := aPragmaWithWildcards pragma key subStrings: ':'.
	argToMatch := aPragmaWithWildcards pragma arguments.
	wildcardNames := aPragmaWithWildcards wildcardNames.
	wildcardArgs := aPragmaWithWildcards wildcardArgs.
		
	"same size args and names"
	(keywords size == keyToMatch size and: [arguments size == argToMatch size]) ifFalse: [^false].
	
	"match name"
	(keywords == keyToMatch) ifFalse:[
		(1 to: keywords size) do:[:index|
			(wildcardNames includes: index) ifFalse:[
				((keywords at: index) = (keyToMatch at: index) ) ifFalse: [^false]
			]
		].
	].
	"match arguments"
	(arguments == argToMatch ) ifFalse:[
		(1 to: arguments size) do:[:index|
			(wildcardArgs includes: index) ifFalse:[
				( self argument:(arguments at: index) equal: (argToMatch at: index) ) ifFalse: [^false]
			]
		].
	].
	 ^true.! !

!PhPragmaMatcher methodsFor: 'private' stamp: 'mcamp 10/1/2012 21:10'!
pragmaFromText: aText

	|text|
	text := aText copy.
	text append:'>'.
	text prepend:'<'.
	text prepend: 'fake '.
	
	^(Parser new parse: text readStream class: PhPragmaMatcher) properties pragmas at: 1.! !

!PhPragmaMatcher methodsFor: 'private' stamp: 'mcamp 10/1/2012 19:27'!
pragmasFromString: aString

	^(Parser new parse: aString readStream class: PhPragmaMatcher) properties pragmas.! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/22/2012 15:40'!
restrictionMethods

	withinMethods isEmptyOrNil 
		ifTrue:[^ withinClass allMethods]
		ifFalse:[^withinMethods].! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:34'!
withinClass
	^ withinClass! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:34'!
withinClass: anObject
	withinClass := anObject! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 12:50'!
withinMethods
	^ withinMethods! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 12:50'!
withinMethods: anObject
	withinMethods := anObject! !

Object subclass: #PhPragmaWithWildcards
	instanceVariableNames: 'pragma wildcardNames wildcardArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPragmaWithWildcards methodsFor: 'adding' stamp: 'mcamp 10/1/2012 20:07'!
addWildcardArgs: aNumber

	wildcardArgs add: aNumber.! !

!PhPragmaWithWildcards methodsFor: 'adding' stamp: 'mcamp 10/1/2012 20:07'!
addWildcardName: aNumber

	wildcardNames add: aNumber.! !

!PhPragmaWithWildcards methodsFor: 'initialize-release' stamp: 'mcamp 10/1/2012 20:14'!
initialize

	wildcardArgs := OrderedCollection new.
	wildcardNames := OrderedCollection new.! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
pragma
	^ pragma! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
pragma: anObject
	pragma := anObject! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardArgs
	^ wildcardArgs! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardArgs: anObject
	wildcardArgs := anObject! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardNames
	^ wildcardNames! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardNames: anObject
	wildcardNames := anObject! !

Object subclass: #PhReceiverMatcher
	instanceVariableNames: 'receiverNames receiverNamesClean withinClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhReceiverMatcher class methodsFor: 'utilities' stamp: 'MiguelCampusano 8/16/2012 02:20'!
class: aClass inheritsFromClassIn: anOrederedCollection
	
 	anOrederedCollection do:[:class| (aClass inheritsFrom: class) ifTrue:[^true]].	
	^false.! !

!PhReceiverMatcher class methodsFor: 'instance creation' stamp: 'MiguelCampusano 8/16/2012 01:55'!
receivers: aString
	|ob|
	ob := self new.
	ob receiverNames: aString;
		cleanFromCharacteres.
	^ob.
	! !

!PhReceiverMatcher methodsFor: 'parsing' stamp: 'MiguelCampusano 8/18/2012 22:41'!
cleanFromCharacteres
	
 	receiverNamesClean:= ((receiverNames subStrings: '+' )at:1). "if have to match subclass (+)"
	receiverNamesClean:= ((receiverNamesClean subStrings: ' ' )at:1). "if have to match metaclass (class)"! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/18/2012 23:48'!
getAllReceiversThatMatch

	|classes|
 
	self ifNeedToMatchSubclass
		ifTrue:[classes := self getClassAndSubclassThatMatch]
		ifFalse:[classes := self getClassesThatMatch.].
	
	self ifNeedToMatchMetaclass
		ifTrue:[^classes collect:[:aClass| aClass class]]
		ifFalse:[^classes].
	! !

!PhReceiverMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/16/2012 02:21'!
getClassAndSubclassThatMatch
	"return all classes that matches receiverName"

	|matchesClasses matchesClassesSubclasses|
	
	matchesClassesSubclasses := Set new.
	matchesClasses := self getClassesThatMatch.
	matchesClassesSubclasses addAll: matchesClasses.
	matchesClassesSubclasses addAll: (self getRestrictionClasses select: [:aClass| PhReceiverMatcher class: aClass inheritsFromClassIn: matchesClasses]).
	
	^matchesClassesSubclasses.  ! !

!PhReceiverMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/16/2012 00:37'!
getClassesThatMatch

	 ^self getRestrictionClasses select: [:aClass| self matchesWithoutSubclasses: aClass asString.]! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:46'!
getRestrictionClasses

	withinClasses isNil 
		ifTrue: [^Smalltalk allClasses]
		ifFalse: [^withinClasses].! !

!PhReceiverMatcher methodsFor: 'testing' stamp: 'MiguelCampusano 8/18/2012 22:38'!
ifNeedToMatchMetaclass

	^'* class*' match: receiverNames
	

	! !

!PhReceiverMatcher methodsFor: 'testing' stamp: 'MiguelCampusano 8/16/2012 01:39'!
ifNeedToMatchSubclass

	^'*+' match: receiverNames
		
	! !

!PhReceiverMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/19/2012 19:55'!
matchesWithoutSubclasses: aReceiverName
	"return true if receiverNames match a aReceiverName. 
	In our regular expressions a '*' mean '.' in a normal regular expressions"

	|newRegExp|
	newRegExp := receiverNamesClean copyWithRegex: '\*' matchesReplacedWith: '.*'.
	^ aReceiverName matchesRegex: newRegExp. ! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 00:49'!
receiverNames
	^ receiverNames! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/16/2012 01:38'!
receiverNames: aString
	receiverNames := aString.! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/16/2012 01:12'!
receiverNamesClean
	^ receiverNamesClean! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/16/2012 01:12'!
receiverNamesClean: anObject
	receiverNamesClean := anObject! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 01:37'!
withinClasses
	^ withinClasses! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 01:37'!
withinClasses: aList
	withinClasses := aList! !

Object subclass: #PhSelectorMatcher
	instanceVariableNames: 'selectorNames withinClasses inMetaclass negation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhSelectorMatcher class methodsFor: 'instance creation' stamp: 'MiguelCampusano 8/14/2012 02:48'!
receivers: aListOfClasses selectors: aSelector
	^ self new 
		withinClasses: aListOfClasses; 
		selectorNames: aSelector.! !

!PhSelectorMatcher class methodsFor: 'instance creation' stamp: 'MiguelCampusano 8/14/2012 02:39'!
selectors: aString
	^ self new selectorNames: aString.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'mcamp 10/19/2012 03:42'!
getAllMethodsThatMatchOfClass: aClass
	"consider all methods in aClass an it superclass"
	|selectors|
	selectors := OrderedCollection new.
	selectors addAll: (aClass methods select: [:aMethod| self matches: aMethod selector asString]).
	
	^selectors.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 03:15'!
getAllSelectorsThatMatch
	"Don't consider the methods in the superclasses"
	
	|selectors|
	selectors := OrderedCollection new.
	withinClasses do:[:aClass| selectors addAll: (aClass methods select: [:aMethod| self matches: aMethod selector asString]) ].
	
	^selectors.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/18/2012 23:14'!
getAllSelectorsThatMatchOfClass: aClass
	"consider all methods in aClass an it superclass"
	|selectors|
	selectors := OrderedCollection new.
	selectors addAll: (aClass allSelectors select: [:aSelector| self matches: aSelector asString]).
	
	^selectors.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/18/2012 23:26'!
getAllSelectorsThatMatchOfMetaclass: aClass
	"consider all methods in aClass an it superclass"
	|selectors|
	selectors := OrderedCollection new.
	selectors addAll: (aClass allSelectors select: [:aSelector| self matches: aSelector asString]).
	
	^selectors.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/15/2012 23:31'!
inMetaclass
	^ inMetaclass! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/15/2012 23:31'!
inMetaclass: anObject
	inMetaclass := anObject! !

!PhSelectorMatcher methodsFor: 'matching' stamp: 'mcamp 9/23/2012 19:10'!
matches: aSelectorString
	"return true when a selector in selectorNames matches aSelectorString "

	selectorNames isString 
		ifTrue:[
			^ self regExp: selectorNames matches: aSelectorString	
		]
		ifFalse: [
			selectorNames do:[:s|
				(self regExp: s matches: aSelectorString) ifTrue:[^true].
			].
		].
	^false.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:15'!
negation
	^ negation! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:15'!
negation: anObject
	negation := anObject! !

!PhSelectorMatcher methodsFor: 'matching' stamp: 'mcamp 9/23/2012 19:06'!
regExp: aRegExp matches: aSelectorString 
	"return true if aRegExp match aSelectorString. 
	In our regular expressions a '_' mean that matches any word in a method name.
	ie: #methodname: 'bar:baz:' matches: 'bar:_:' 			-- true"

	|collectMethod collectRegExp|
				
	((aSelectorString matchesRegex: '.*\:') xor: (aRegExp matchesRegex: '.*\:')) ifTrue: [^false].

	collectMethod := aSelectorString subStrings: ':'.
	collectRegExp := aRegExp subStrings: ':'.
	collectMethod size = collectRegExp size ifFalse: [^false].

	collectMethod with: collectRegExp do: [:a :b| (self singleSelector: a matches: b) ifFalse: [^false]].
	 ^true.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
selectorNames
	^ selectorNames! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
selectorNames: anObject
	selectorNames := anObject! !

!PhSelectorMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/14/2012 02:05'!
singleSelector: aSelectorName matches: aRegExp
	"return true if aRegExp match single methodName"

	|newRegExp|
	
	newRegExp := aRegExp.
	aRegExp = '_' ifTrue: [newRegExp := aRegExp copyWithRegex: '_' matchesReplacedWith: '\w+'].

	^aSelectorName matchesRegex: newRegExp.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
withinClasses
	^ withinClasses! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
withinClasses: anObject
	withinClasses := anObject! !

Object subclass: #PhSourceBuilder
	instanceVariableNames: 'classBuilder source selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/28/2012 00:27'!
adviceVar

	^'phAdvice'.! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 9/19/2012 22:13'!
afterAdvice

	^'"After Advice"'! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/26/2012 23:38'!
argsVar
	
	^'phArgsVar'! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 9/24/2012 03:43'!
aroundAdvice

	^'"Around Advice - in reverse order of execution"'! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/23/2012 23:45'!
aroundVar

	^'phAroundAdvice'.! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 9/19/2012 22:13'!
beforeAdvice

	^'"Before Advice"'! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 9/19/2012 22:12'!
beginAutogenerate

	^'"Begin Autogenerated Casper code"'! !

!PhSourceBuilder class methodsFor: 'generated method' stamp: 'mcamp 9/26/2012 20:26'!
casperCategory

	^ 'casper autogenerated'.! !

!PhSourceBuilder class methodsFor: 'generated method' stamp: 'mcamp 10/11/2012 15:34'!
casperClassModifiedCategory

	^ 'casper class modifiers'.! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/20/2012 04:06'!
contextVar

	^'phCtx'.! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 9/19/2012 22:13'!
endAutogenerate

	^ '"End Autogenerated Casper code"'! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 10/11/2012 12:29'!
explanationComment: methodName

	^' "This method has been modified by Casper. The original implementation can be found in ',methodName,'" '.! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/24/2012 00:40'!
originalVar

	^'phOriginalMethod'.! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 10/11/2012 13:09'!
preProcessing

	^'"Casper pre-processing"'! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/27/2012 02:35'!
receiverVar

	^'phReceiver'.! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/27/2012 03:34'!
returnVar

	^'phReturn'.! !

!PhSourceBuilder class methodsFor: 'parsing' stamp: 'mcamp 10/2/2012 03:02'!
selectorOfSource: aSource class: aClass

	^(Parser new parse: aSource readStream class: aClass) selector.! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/24/2012 00:48'!
senderVar

	^'phSender'.! !

!PhSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 9/24/2012 02:43'!
startExecution

	^'"Execution"'! !

!PhSourceBuilder class methodsFor: 'context text' stamp: 'mcamp 10/11/2012 20:29'!
textOfContext: context

	|text|
	
	text := Text new.
	
	"eliminar ifelse"
	self flag:#refactoring.
	text append: String tab, PhSourceBuilder contextVar, ' := PhContext new.', String cr.
	context isEmptyOrNil ifFalse:[
		context do:[:ctx| 
			ctx == #receiver ifTrue:[text append: String tab, PhSourceBuilder contextVar, ' receiver: self.', String cr].
			ctx == #sender ifTrue:[text append: String tab, PhSourceBuilder contextVar, ' sender: thisContext sender receiver.', String cr].
			ctx == #arguments ifTrue: [text append: String tab, PhSourceBuilder contextVar, ' arguments: ', PhSourceBuilder argsVar,'.', String cr].
			ctx == #selector ifTrue: [text append: String tab, PhSourceBuilder contextVar, ' selector: thisContext method selector.', String cr].
		]	
	].
	
	^text.! !

!PhSourceBuilder class methodsFor: 'context text' stamp: 'mcamp 10/23/2012 23:08'!
textOfContextAtAround: advice withIndex: index

	|text ctxText context ctxTextNext|
	
	context := advice pointcut context.
	
	text := Text new.
	ctxText := PhSourceBuilder contextVar,index asString.
	ctxTextNext := PhSourceBuilder contextVar,(index+1) asString.
	"eliminar ifelse"
	self flag:#refactoring.
	text append: String tab, ctxText, ' := ', PhSourceBuilder contextVar, ' copy.', String cr.
	context isEmptyOrNil ifFalse:[
		(context includes: #thisAdvice)
			ifTrue:[text append: String tab, PhSourceBuilder contextVar, ' thisAdvice: ', (self thisAdviceSource: advice at: index),'.',String cr].
		((context includes: #proceed) or:[advice hasIfPointcut])
			ifTrue:[
				text append:  String tab, ctxText, ' proceed: ', PhSourceBuilder aroundVar, (index + 1) asString, '.', String cr.
				text append:  String tab, ctxText, ' nextContext: ',ctxTextNext, '.', String cr.
			]
	].
	
	
	^text.! !

!PhSourceBuilder class methodsFor: 'context text' stamp: 'mcamp 10/23/2012 23:08'!
textOfContextAtFirstAround: advice withIndex: index

	|text ctxText context|
	
	context := advice pointcut context.
	
	text := Text new.
	ctxText := PhSourceBuilder contextVar,index asString.
	"eliminar ifelse"
	self flag:#refactoring.
	text append: String tab, ctxText, ' := ', PhSourceBuilder contextVar, ' copy.', String cr.
	context isEmptyOrNil ifFalse:[
		(context includes: #thisAdvice)
			ifTrue:[text append: String tab, PhSourceBuilder contextVar, ' thisAdvice: ', (self thisAdviceSource: advice at: index),'.',String cr].
		((context includes: #proceed) or: [advice hasIfPointcut])
			ifTrue:[
				text append:  String tab, ctxText, ' proceed: ', PhSourceBuilder originalVar, '.', String cr.
				text append:  String tab, ctxText, ' isOriginal: true.', String cr.
			]
	].
	
	
	^text.! !

!PhSourceBuilder class methodsFor: 'generated method' stamp: 'mcamp 10/11/2012 12:06'!
toAppendOnSelector

	|counter|
	counter := PhAspectWeaver getCounterAndAddOne.
	^ 'casper', counter asString.! !

!PhSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 9/28/2012 00:26'!
wrapperVar

	^'phWrapper'.! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 9/28/2012 02:11'!
allTmpVar

	^PhSourceBuilder aroundVar, ' ', PhSourceBuilder contextVar, ' ', PhSourceBuilder originalVar, ' ', PhSourceBuilder senderVar, ' ', PhSourceBuilder argsVar, ' ', PhSourceBuilder receiverVar, ' ',PhSourceBuilder returnVar, ' ', PhSourceBuilder wrapperVar, ' ', PhSourceBuilder adviceVar.! !

!PhSourceBuilder methodsFor: 'private' stamp: 'mcamp 9/27/2012 01:56'!
argumentsOfSource: aSource class: aClass

	^(Parser new parse: aSource readStream class: classBuilder) arguments collect: [:arg| arg key].
	! !

!PhSourceBuilder methodsFor: 'building context' stamp: 'mcamp 10/11/2012 13:45'!
buildAdviceContext: advice at: index

	|text context |
	
	text := Text new.
	context := advice pointcut context.
	"eliminar ifelse"
	self flag:#refactoring.
	context isEmptyOrNil 
	ifTrue:[
		text append: String tab, PhSourceBuilder contextVar, ' thisAdvice: nil.', String cr.
	]
	ifFalse:[
		(context includes: #thisAdvice)
			ifTrue:[text append: String tab, PhSourceBuilder contextVar, ' thisAdvice: ', (self thisAdviceSource: advice at: index),'.',String cr]
			ifFalse:[text append: String tab, PhSourceBuilder contextVar, ' thisAdvice: nil.', String cr].
	].
	
	^text.! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 10/22/2012 21:19'!
buildAdviceOrSend: advice at: index

	|text|
	
	text := Text new.
	(advice isSend or: [advice hasIfPointcut])
		ifTrue:[text append: String tab, PhSourceBuilder adviceVar , ' := ',(self thisAdviceSource: advice at: index),'.',String cr.].
	advice hasIfPointcut ifTrue:[
		text append: String tab, '(', PhSourceBuilder adviceVar,' shouldExecuteOn: ', PhSourceBuilder contextVar, ')', String cr.
		text append: String tab, String tab,  'ifTrue:[', String cr.
		text append: String tab, String tab.
	].
	
	advice isSend 
		ifFalse: [ 
			text append: (String tab, advice advice asString, ' value: ', PhSourceBuilder contextVar,'.', String cr) asText
		]
		ifTrue: [
			advice objectSend isBlock
				ifTrue:[
					text append: String tab, '(', PhSourceBuilder adviceVar, ' objectSend value: ', PhSourceBuilder contextVar ,')', 'perform: #', advice selectorSend,' with: ', PhSourceBuilder contextVar,'.', String cr.
				]
				ifFalse:[
					text append: String tab, PhSourceBuilder adviceVar, ' objectSend perform: #', advice selectorSend,' with: ', PhSourceBuilder contextVar,'.', String cr.
				].
		].
	
	advice hasIfPointcut 
		ifTrue:[text append: String tab, String tab, '].', String cr].
	
	^text. ! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 10/24/2012 23:20'!
buildAdviceOrSendToAround: advice at: index

	|text|
	
	text := Text new.
	(advice hasIfPointcut or: [advice isSend])
		ifTrue:[
			text append: String tab, PhSourceBuilder adviceVar , ' := ',(self thisAdviceSource: advice at: index), '.',String cr.
		].
	text append: String tab, PhSourceBuilder aroundVar,index asString, ' := ', String cr.
	advice hasIfPointcut ifTrue:[
		text append: String tab, String tab,  '(', PhSourceBuilder adviceVar ,' shouldExecuteOn: phAroundContext)',String cr.
		text append: String tab, String tab, String tab,  'ifTrue:[',String cr.
		text append: String tab,String tab, String tab.
	].

	advice isSend 
		ifFalse: [text append: advice advice asString asText]
		ifTrue:[
		advice objectSend isBlock
			ifTrue:[
				text append: String tab, '[:ctx| (phAdvice objectSend value: ctx) perform: #', advice selectorSend,' with: ctx ]'.
			]
			ifFalse:[
				text append:  String tab, '[:ctx| phAdvice objectSend perform: #', advice selectorSend,' with: ctx ]'.
			].
		].
	
	advice hasIfPointcut 
	ifTrue:[
		text append: String tab, String tab, String tab, String tab, String tab,  ']',String cr.
		text append: String tab,String tab, String tab, String tab, String tab, 'ifFalse:[',String cr.
		text append: String tab,String tab, String tab, String tab, String tab, String tab, '[:ctx| ctx proceed].', String cr.
		text append: String tab,String tab, String tab, String tab, String tab, ']',String cr.
		text append: String tab, String tab, String tab,  '].',String cr.
	]
	ifFalse: [
		text append: '.',String cr.
	].

	^text.! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 10/24/2012 23:57'!
buildAdviceOrSendToAround: advice at: index withContext: aCtx

	|text|
	
	text := Text new.
	(advice hasIfPointcut or: [advice isSend])
		ifTrue:[
			text append: String tab, PhSourceBuilder adviceVar , ' := ',(self thisAdviceSource: advice at: index), '.',String cr.
		].
	text append: String tab, PhSourceBuilder aroundVar,index asString, ' := ', String cr.
	advice hasIfPointcut ifTrue:[
		text append: String tab, String tab,  '(', PhSourceBuilder adviceVar ,' shouldExecuteOn: ', aCtx, ')',String cr.
		text append: String tab, String tab, String tab,  'ifTrue:[',String cr.
		text append: String tab, String tab, String tab.
	].

	advice isSend 
		ifFalse: [text append: String tab, advice advice asString asText]
		ifTrue:[
		advice objectSend isBlock
			ifTrue:[
				text append: String tab, '[:phInnerAroundAdvice| [:ctx| (phInnerAroundAdvice objectSend value: ctx) perform: #', advice selectorSend,' with: ctx ] ] value: ', PhSourceBuilder adviceVar.
			]
			ifFalse:[
				text append:  String tab, '[:phInnerAroundAdvice| [:ctx| phInnerAroundAdvice objectSend perform: #', advice selectorSend,' with: ctx ] ] value: ', PhSourceBuilder adviceVar.
			].
		].
	
	advice hasIfPointcut 
	ifTrue:[
		text append: String cr, String tab, String tab, String tab, ']',String cr.
		text append: String tab,String tab, String tab, 'ifFalse:[',String cr.
		text append: String tab,String tab, String tab, String tab,'[:ctx| ctx proceed].', String cr.
		text append: String tab,String tab, String tab, ']',String cr.
	]
	ifFalse: [
		text append: '.',String cr.
	].

	^text.! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 10/11/2012 13:30'!
buildAfterSource: advices

	advices isEmpty 
		ifFalse:[ |index|
			source append: String cr.
			source append: String tab, PhSourceBuilder afterAdvice ,String cr.
			index := 1.
			advices do:[:adv| 
				source append: (self buildAdviceContext: adv at: index).
				source append: (self buildAdviceOrSend: adv at: index).
				index := index + 1.
			].
		]
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 9/27/2012 03:28'!
buildArguments

	|text args|
	text := Text new.
	text append: String tab,PhSourceBuilder argsVar, ' := OrderedCollection new.', String cr.
	
	args := self argumentsOfSource: source class: classBuilder.
	args isEmptyOrNil ifFalse:[
		text append: String tab, PhSourceBuilder argsVar,String cr.
		args do:[:arg|
			text append: String tab, String tab,	 'add: ',arg, ';', String cr.
		].
		text at: (text size - 1) put: $..
		text append: String cr.
	].
	source append: text.! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 10/24/2012 23:46'!
buildAroundSource: advices

	advices isEmpty 
		ifFalse:[ | generatedText firstAdvice aroundText ctxText|
			
			generatedText := Text new.
				
			generatedText append: String tab, PhSourceBuilder aroundAdvice ,String cr.
			generatedText append: String tab, PhSourceBuilder senderVar, ' := thisContext sender receiver.', String cr.
			firstAdvice := true.
			
			"genero wrapper global para aroundAdvices"
			aroundText :=  PhSourceBuilder aroundVar.
			ctxText := PhSourceBuilder contextVar.
			generatedText append: String tab, aroundText, ' := [' , String cr.
			"2n variables temporales"
			generatedText append: String tab, '|'.
			(1 to: advices size ) reverse do: [ :index|
				generatedText append: ctxText,index asString,' ',aroundText,index asString,' '.
			].
			generatedText append: '|',String cr.
			generatedText append: String tab, ctxText,' thisAdvice: nil.', String cr.
			"genero advices"
			(1 to: advices size ) reverse do: [ :index|
				|lastAround|
				lastAround := index == advices size.
				"genero contexto"
				lastAround
					ifTrue:[
						generatedText append: (PhSourceBuilder textOfContextAtFirstAround: (advices at: index ) withIndex: index).
					]
					ifFalse:[
						generatedText append: (PhSourceBuilder textOfContextAtAround: (advices at: index ) withIndex: index).
					].
				"genero advice"
				generatedText append: (self buildAdviceOrSendToAround:(advices at: index) at: index withContext:  PhSourceBuilder contextVar,index asString).
				

			].
			"primera ejecucion"
			generatedText append: String tab, aroundText, '1 value: ',ctxText,'1.',String cr.
			generatedText append: String tab, '].' , String cr.
			
			source append: generatedText.
		]! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 10/11/2012 13:29'!
buildBeforeSource: advices

	advices isEmpty 
		ifFalse:[ |generatedText index|
			
			generatedText := Text new.
			generatedText append: String tab, PhSourceBuilder beforeAdvice ,String cr.
			index := 1.
			advices do:[:adv| 
				generatedText append: (self buildAdviceContext: adv at: index).
				generatedText append: (self buildAdviceOrSend: adv at: index).
				index := index + 1.
			].
			
			source append: generatedText.
		]! !

!PhSourceBuilder methodsFor: 'building context' stamp: 'mcamp 10/11/2012 12:54'!
buildCommonContext: contexts
	| generate|
	
	generate := Text new.
	
	generate 
		append: (PhSourceBuilder textOfContext: contexts).
	source append: generate.
	
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/11/2012 01:06'!
buildExecutionSource: aBoolean

	source append: String tab, PhSourceBuilder startExecution ,String cr.
	source append: String tab, PhSourceBuilder returnVar, ' := '.
	aBoolean 
		ifTrue:[source append: PhSourceBuilder originalVar ,' value.',String cr.]
		ifFalse:[source append: PhSourceBuilder aroundVar ,' value.',String cr.].
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/18/2012 03:19'!
buildFirstComment: aSelector
	| generate|
	
	generate := Text new.
	generate 
		append: String cr;
		append: (PhSourceBuilder explanationComment: aSelector);
		append: String cr, String cr.
	source append: generate.
	
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/12/2012 03:00'!
buildNewSelectorWithArgs: aCasperName
	
	|arguments|
	
	arguments := self argumentsOfSource: source class: classBuilder.
	
	arguments do:[:anArg|
		|index|
		index := source findString: anArg startingAt: 0.
		source at: index put: (source at: index) asUppercase.
		source replaceFrom: index to: index - 1 with: aCasperName.	
	].! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/16/2012 03:50'!
buildNewSource: wrappers
	
	"first time, create casper method"
	self flag:#sacarLogica.
	self createCasperMethodOf: wrappers.
	
	self cleanOriginalSource.
	self buildNewSelectorWithArgs: wrappers casperCounter.
	self buildFirstComment: wrappers casperSelector.
	self buildTempVar.
	self buildPreProcessing.
	self buildArguments.
	self buildCommonContext: wrappers commonContext.
	self buildBeforeSource: wrappers beforeAdvices.
	self buildOriginalCall: wrappers casperSelector.
	self buildAroundSource: wrappers aroundAdvices.
	self buildExecutionSource: wrappers aroundAdvices isEmptyOrNil.
	self buildAfterSource: wrappers afterAdvices.
	self buildReturnStatement.
	^source.
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/11/2012 15:10'!
buildOriginalCall: casperSelector
	
	|generatedText initIndex|
	
	generatedText := Text new.
	"this is wrong, just for testing porpuse, correct has to be after inst var if there are"
	self flag:#correctIndex.
	initIndex := source findString: String cr startingAt:1.
			
	generatedText append: String tab, PhSourceBuilder originalVar, ' := [:args|', String cr. 
	generatedText append: String tab, '[', String cr. 
	generatedText append: String tab, PhSourceBuilder receiverVar, ' perform: #', casperSelector,' withArguments: args.',String cr.
	generatedText append: String cr.
	generatedText append: String tab, ']', String cr. 
	generatedText append: String tab, '] value: ', PhSourceBuilder argsVar ,' asArray.',String cr.
	
	source append: generatedText.! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 9/24/2012 03:35'!
buildOriginalSource
	
	|generatedText initIndex|
	
	generatedText := Text new.
	"this is wrong, just for testing porpuse, correct has to be after inst var if there are"
	self flag:#correctIndex.
	initIndex := source findString: String cr startingAt:1.
			
	generatedText append:String tab, PhSourceBuilder beginAutogenerate ,String cr.
	generatedText append: String tab, PhSourceBuilder originalVar, ' := [', String cr. 
	generatedText append: String tab, PhSourceBuilder endAutogenerate , String cr.
	generatedText append: (source copyFrom: (initIndex + 1) to: source size).
	
	generatedText append: String cr.
	generatedText append:String tab, PhSourceBuilder beginAutogenerate ,String cr.
	generatedText append: String tab, '].', String cr.
	generatedText append: String tab, PhSourceBuilder endAutogenerate , String cr.
	
	^generatedText .! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/11/2012 15:28'!
buildPreProcessing
	| generate|
	
	generate := Text new.
	generate 
		append: String tab, (PhSourceBuilder preProcessing);
		append: String cr.
	source append: generate.
	
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 9/27/2012 03:36'!
buildReturnStatement

	source append: String cr.
	source append: String tab, '^',PhSourceBuilder returnVar.
	! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/11/2012 01:04'!
buildTempVar
	| generate|
	
	generate := Text new.
	generate 
		append: String tab, '|'; 
		append: self allTmpVar;
		append: '|' , String cr.
	
	self flag: #takeAway.
	generate append: String tab, PhSourceBuilder receiverVar, ' := self.',String cr.
	generate append: String tab, PhSourceBuilder wrapperVar, ' := PhAspectWeaver getInstalledWrapperOf: ', classBuilder asString , ' selector: #',selector asString,'.',String cr.
	source append: generate.
	
	! !

!PhSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 9/27/2012 04:42'!
changeBackSource: aCasperSource

	"delete casper prepend"
	aCasperSource replaceFrom:1 to: PhSourceBuilder toAppendOnSelector size with: ''.
	
	"change case of first character"
	aCasperSource at:1 put: (aCasperSource at: 1) asLowercase.
	
	source := aCasperSource.! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/11/2012 14:56'!
changeToOriginalMethod: casperSelector

	self cleanCasperMethod: casperSelector.
	^source.! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 9/13/2012 00:42'!
classBuilder
	^ classBuilder! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 9/13/2012 00:43'!
classBuilder: aClass
	classBuilder:= aClass! !

!PhSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 10/11/2012 14:57'!
cleanCasperMethod: casperSelector

	|cCategory|
	self changeBackSource: (classBuilder methodDict at: casperSelector ) sourceCode asText.
	classBuilder removeSelector: casperSelector.
	
	cCategory := PhSourceBuilder casperCategory.
	(classBuilder organization listAtCategoryNamed: cCategory)
		isEmptyOrNil ifTrue: [classBuilder removeCategory: cCategory] ! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 10/18/2012 03:21'!
cleanOriginalSource

	|initIndex|

	initIndex := self getEndIndexOfSelector.
	source replaceFrom: (initIndex + 1) to: source size with: ''.! !

!PhSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 10/16/2012 03:51'!
createCasperMethodOf: aWrapper
	
	|casperSource|
	aWrapper casperCounter ifNil: [aWrapper casperCounter:  PhSourceBuilder toAppendOnSelector].
	casperSource := source copy.
	casperSource at: 1 put: (casperSource at:1) asUppercase.
	casperSource prepend: aWrapper casperCounter.
	
	"compilar"
	aWrapper casperSelector: (classBuilder compile: casperSource classified: PhSourceBuilder casperCategory)! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 10/12/2012 03:25'!
getEndIndexOfSelector 

	|arguments|
	arguments := self argumentsOfSource: source class: classBuilder.
	
	arguments isEmpty 
		ifTrue:[
			|s index|
			s := self selectorOfSource: source class: classBuilder.
			index := source findString: s startingAt: 0.
			^index + s size - 1.
			
		]
		ifFalse:[
			|maxIndex maxArg|
			maxIndex := 0.
			arguments do:[:arg|
				|index|
				index := source findString:arg startingAt: 0.
				(maxIndex < index)  ifTrue:[
					maxIndex := index.
					maxArg := arg.
				].
			].
			^maxIndex + maxArg size - 1.			
		]! !

!PhSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 10/16/2012 03:04'!
originalSourceCodeOf: originalSelector casperSelector: casperSelector

	self changeBackSource: (classBuilder methodDict at: casperSelector ) sourceCode asText.	
	^source.! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 9/26/2012 19:19'!
selector
	selector ifNil: [selector := (Parser new parse: source readStream class: classBuilder) selector.].
	^ selector.! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:16'!
selector: aSelector
	selector := aSelector! !

!PhSourceBuilder methodsFor: 'private' stamp: 'mcamp 9/27/2012 00:44'!
selectorOfSource: aSource class: aClass

	^(Parser new parse: aSource readStream class: classBuilder) selector.
	! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 9/12/2012 23:10'!
source
	^ source! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 9/13/2012 00:44'!
source: aText
	source := aText.! !

!PhSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 9/28/2012 02:08'!
thisAdviceSource: advice at: index
	^PhSourceBuilder wrapperVar,' advices ', advice type, ' at:', index asString.! !
PhAspectWeaver initialize!
